/** A class that exports a native method. */
class HelloWorld {
	/** Print a message to stdout.
	 * This method illustrates a native method written in C.
	 */
	public native void displayHelloWorld();

	/* The following is done whenever the class HelloWorld is first loaded */
	static {
		/* Explicitly load the implementation of the method.  An absolute
		 * pathname (including a drive letter on Windows platforms) is
		 * required.  The following assumes that this program is invoked
		 * from the directory in which it was built.
		 *
		 * Alternatively, name the implementation "libhello.so", make sure the
		 * environment contains LD_LIBRARY_PATH=dir1:dir2:..., make sure
		 * libhello.so appears in one of those dirs, and use System.loadLibrary
		 * rather than System.load as shown below.
		 */
		String cwd = System.getProperty("user.dir");
		System.load(cwd + "/hello_world.o");

		/* To use the following version, comment-out the previous line and
		 * modify the Makefile as indicated there.
		 */
		// System.loadLibrary("hello");
	}
}
